/*  _ __   __ _ ___ __  __
** | '_ \ / _` |_ _|  \/  | naim
** | | | | (_| || || |\/| | Copyright 1998, 1999 Daniel Reed <n@ml.org>
** |_| |_|\__,_|___|_|  |_| ncurses-based, FAIM-based AIM client
**
** FAIM Copyright 1998 Adam Fritzler <afritz@iname.com>
** FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
*/
#include <naim.h>

extern WINDOW	*win_status;
extern buddywin_t	*curbwin, nullbwin;
extern int	wsetup_called;
extern time_t	now;

#define WINPRINTF(win) { \
	char	buf[11]; \
	va_list	msg; \
	struct tm	*tptr = localtime(&now); \
\
	assert(format != NULL); \
	while (*format == '\n') \
		format++; \
	snprintf(buf, sizeof(buf), "[%02i:%02i:%02i]", tptr->tm_hour, \
		tptr->tm_min, tptr->tm_sec); \
	if (wsetup_called == 1) { \
		wattrset(win, COLOR_PAIR(STAT_TEXT)); \
		waddstr(win, buf); \
		wattrset(win, A_BOLD | COLOR_PAIR(IMWIN_TEXT_U)); \
		waddstr(win, " *** "); \
		wattrset(win, A_BOLD | COLOR_PAIR(STAT_TEXT)); \
		va_start(msg, format); \
		vwprintw(win, (char *)format, msg); \
		va_end(msg); \
		wattrset(win, 0); \
		bupdate(); \
	} else if (wsetup_called == 2) { \
		va_start(msg, format); \
		vwprintw(stdscr, (char *)format, msg); \
		va_end(msg); \
		wrefresh(stdscr); \
	} else { \
		va_start(msg, format); \
		vprintf(format, msg); \
		va_end(msg); \
	} \
}

int	sechof(const char *format, ...) {
	WINPRINTF(win_status);
	nullbwin.waiting = 1;
	if (wsetup_called == 1)
		bupdate();

	return(1);
}

int	wechof(buddywin_t *bwin, const char *format, ...) {
	WINPRINTF(bwin->win);
	bwin->waiting = 1;
	if (wsetup_called == 1)
		bupdate();

	return(1);
}

int	cechof(const char *format, ...) {
	WINPRINTF(curbwin->win);

	return(1);
}

void	perror(const char *str) {
	if (errno != 0)
		debug_printf("ERROR %i in %s: %s\n", errno, str,
			strerror(errno));
	else
		debug_printf("ERROR in %s\n", str);
#ifdef PERROR_FATAL
	wshutitdown();
	if (errno != 0)
		fprintf(stderr, "error %i: %s: %s\n", errno, str,
			strerror(errno));
	else
		fprintf(stderr, "error *: %s\n", str);
	exit(1);
#else
	if (errno != 0)
		sechof("!-! ERROR %i in %s: %s\n", errno, str,
			strerror(errno));
	else
		sechof("!-! ERROR in %s\n", str);
#endif
}
